package lejos.realtime;

/**
 *
 * @author Team iRboT
 */
public class MemoryParameters {

    public static final long NO_MAX = 100;  /**mis arbitrairement a revoir*/
/*Specifies no maximum limit.*/

    public long getAllocationRate(){
    /*
     Gets the limit on the rate of allocation in the heap. Units are in bytes per second.
        Returns:
        The allocation rate in bytes per second. If zero, no allocation is allowed in the heap. If the returned value is NO_MAX then the allocation rate on the heap is uncontrolled.
        getMaxImmortal
     */
        throw new UnsupportedOperationException("Not overrided yet.");
    }


    public long getMaxImmortal(){
        /*
         Gets the limit on the amount of memory the schedulable object may allocate in the immortal area. Units are in bytes.
        Returns:
        The limit on immortal memory allocation. If zero, no allocation is allowed in immortal memory. If the returned value is NO_MAX then there is no limit for allocation in immortal memory.
        getMaxMemoryArea
         */
         throw new UnsupportedOperationException("Not overrided yet.");
    }
    
    public long getMaxMemoryArea(){
        /*
         Gets the limit on the amount of memory the schedulable object may allocate in its initial memory area. Units are in bytes.
        Returns:
        The allocation limit in the schedulable object's initial memory area. If zero, no allocation is allowed in the initial memory area. If the returned value is NO_MAX then there is no limit for allocation in the initial memory area.
        setAllocationRate
        */
         throw new UnsupportedOperationException("Not overrided yet.");
    }
    
    public void setAllocationRate(long allocationRate){
        /*
         Sets the limit on the rate of allocation in the heap.
        Parameters:
        allocationRate - Units are in bytes per second of wall-clock time. If allocationRate is zero, no allocation is allowed in the heap. To specify no limit, use NO_MAX. Measurement starts when the schedulable object starts (not when it is constructed.) Enforcement of the allocation rate is an implementation option. If the implementation does not enforce allocation rate limits, it treats all non-zero allocation rate limits as NO_MAX.
        Throws:
        java.lang.IllegalArgumentException - Thrown if any value other than positive, zero, or NO_MAX is passed as the value of allocationRate.
        */

         throw new UnsupportedOperationException("Not overrided yet.");
    }

    public boolean setAllocationRateIfFeasible(long allocationRate){
        /*
         Sets the limit on the rate of allocation in the heap. If this MemoryParameters object is currently associated with one or more schedulable objects that have been passed admission control, this change in allocation rate will be submitted to admission control. The scheduler (in conjunction with the garbage collector) will either admit all the effected threads with the new allocation rate, or leave the allocation rate unchanged and cause setAllocationRateIfFeasible to return false.
        Parameters:
        allocationRate - Units are in bytes per second of wall-clock time. If allocationRate is zero, no allocation is allowed in the heap. To specify no limit, use NO_MAX. Enforcement of the allocation rate is an implementation option. If the implementation does not enforce allocation rate limits, it treats all non-zero allocation rate limits as NO_MAX.
        Returns:
        True if the request was fulfilled.
        Throws:
        java.lang.IllegalArgumentException - Thrown if any value other than positive, zero, or NO_MAX is passed as the value of allocationRate.
        */
         throw new UnsupportedOperationException("Not overrided yet.");
    }


    public boolean setMaxImmortalIfFeasible(long maximum){
        /*
         Sets the limit on the amount of memory the schedulable object may allocate in the immortal area.
        Parameters:
        maximum - Units are in bytes. If zero, no allocation allowed in immortal. To specify no limit, use NO_MAX.
        Returns:
        True if the value is set. False if any of the schedulable objects have already allocated more than the given value. In this case the call has no effect.
        Throws:
        java.lang.IllegalArgumentException - Thrown if any value other than positive, zero, or NO_MAX is passed as the value of maximum.
        */
         throw new UnsupportedOperationException("Not overrided yet.");
    }


    public boolean setMaxMemoryAreaIfFeasible(long maximum){
        /*
         Sets the limit on the amount of memory the schedulable object may allocate in its initial memory area.
        Parameters:
        maximum - Units are in bytes. If zero, no allocation allowed in the initial memory area. To specify no limit, use NO_MAX.
        Returns:
        True if the value is set. False if any of the schedulable objects have already allocated more than the given value. In this case the call has no effect.
        Throws:
        java.lang.IllegalArgumentException - Thrown if any value other than positive, zero, or NO_MAX is passed as the value of maximum.
        */
         throw new UnsupportedOperationException("Not overrided yet.");
    }

}
