package lejos.realtime;

/**
 *
 * @author Team iRbot
 */
public class ProcessingGroupParameters implements Cloneable{

    public ProcessingGroupParameters() {
        throw new UnsupportedOperationException("Not supported yet.");
    }


    

    @Override
    public java.lang.Object clone(){
       /*
        Return a clone of this. This method should behave effectively as if it constructed a new object with clones of the high-resolution time values of this.
        The new object is in the current allocation context.
        clone does not copy any associations from this and it does not implicitly bind the new object to a SO.
        The new object has clones of all high-resolution time values (deep copy).
        References to event handlers are copied (shallow copy.)
        Overrides:
        clone in class java.lang.Object
        Since:
        1.0.1
        */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public RelativeTime getCost(){
        /*
         Gets the value of cost.
        Returns:
        a reference to the value of cost.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public AsyncEventHandler getCostOverrunHandler(){
        /*
         Gets the cost overrun handler.
        Returns:
        A reference to an instance of AsyncEventHandlerthat is cost overrun handler of this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public RelativeTime getDeadline(){
        /*
         Gets the value of deadline.
        Returns:
        A reference to an instance of RelativeTime that is the deadline of this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public AsyncEventHandler getDeadlineMissHandler(){
        /*
         Gets the deadline miss handler.
        Returns:
        A reference to an instance of AsyncEventHandlerthat is deadline miss handler of this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public RelativeTime getPeriod(){
        /*
         Gets the value of period.
        Returns:
        A reference to an instance of RelativeTime that represents the value of period.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public HighResolutionTime getStart(){
        /*
         Gets the value of start. This is the value that was specified in the constructor or by setStart(), not the actual absolute time the corresponding to the start of the processing group.
        Returns:
        A reference to an instance of HighResolutionTime that represents the value of start.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setCost(RelativeTime cost){
        /*
         Sets the value of cost.
        Parameters:
        cost - The new value for cost. If null, an exception is thrown.
        Throws:
        java.lang.IllegalArgumentException - Thrown if cost is null or its time value is less than zero.
        IllegalAssignmentError - Thrown if cost cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setCostOverrunHandler(AsyncEventHandler handler){
        /*
         *Sets the cost overrun handler.
        Parameters:
        handler - This handler is invoked if the run() method of and of the the schedulable objects attempt to execute for more than cost time units in any period. If null, no handler is attached, and any previous handler is removed.
        Throws:
        IllegalAssignmentError - Thrown if handler cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setDeadline(RelativeTime deadline){
        /*
         Sets the value of deadline.
        Parameters:
        deadline - The new value for deadline. If null, the default value is new instance of RelativeTime(period).
        Throws:
        java.lang.IllegalArgumentException - Thrown if deadline has a value less than zero or greater than the period. Unless the implementation supports deadline less than period in processing groups, IllegalArgumentException is also thrown if deadline is less than the period.
        IllegalAssignmentError - Thrown if deadline cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setDeadlineMissHandler(AsyncEventHandler handler){
        /*
         Sets the deadline miss handler.
        Parameters:
        handler - This handler is invoked if the run() method of any of the schedulable objects still expect to execute after the deadline has passed. If null, no handler is attached, and any previous handler is removed.
        Throws:
        IllegalAssignmentError - Thrown if handler cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public boolean setIfFeasible(RelativeTime period, RelativeTime cost, RelativeTime deadline){
        /*
         This method first performs a feasibility analysis using the period, cost and deadline attributes as replacements for the matching attributes this. If the resulting system is feasible the method replaces the current attributes of this with the new attributes.
        Parameters:
        period - The proposed period. There is no default value. If period is null an exception is thrown.
        cost - The proposed cost. If null, an exception is thrown.
        deadline - The proposed deadline. If null, the default value is new instance of RelativeTime(period).
        Returns:
        True, if the resulting system is feasible and the changes are made. False, if the resulting system is not feasible and no changes are made.
        Throws:
        java.lang.IllegalArgumentException - Thrown if the period is null or its time value is not greater than zero, or if the time value of cost is less than zero, or if the time value of deadline is not greater than zero.
        IllegalAssignmentError - Thrown if period, cost, or deadline cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setPeriod(RelativeTime period){
        /*
         Sets the value of period.
        Parameters:
        period - The new value for period. There is no default value. If period is null an exception is thrown.
        Throws:
        java.lang.IllegalArgumentException - Thrown if period is null, or its time value is not greater than zero. If the implementation does not support processing group deadline less than period, and period is not equal to the current value of the processing group's deadline, the deadline is set to a clone of period created in the same memory area as period.
        IllegalAssignmentError - Thrown if period cannot be stored in this.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

    public void setStart(HighResolutionTime start){
        /*
         Sets the value of start. If the processing group is already started this method alters the value of this object's start time property, but has no other effect.
        Parameters:
        start - The new value for start. If null, the default value is a new instance of RelativeTime(0,0).
        Throws:
        IllegalAssignmentError - Thrown if start cannot be stored in this.
        java.lang.IllegalArgumentException - Thrown if start is a relative time value and less than zero.
         */
        throw new UnsupportedOperationException("Not overrided yet.");
    }

}
